Program InvTab;          {Vytvari opacnou tabulku}
uses
    Crt;
var
   Vstup,
   Vystup : array [0..255] of byte;
   FOut   : file;

procedure NactiTabulku (nazev : string);
var
   Tabulka : file;
   Nacteno : word;
begin
{$I-}
   assign(tabulka,nazev);
   reset(tabulka,1);
   if IOResult <> 0 then        {Jestli jsou potize ze souborem}
   begin
	  TextColor (LightRed);
	  writeln ('Chyba pri otevirani souboru s tabulkou: ',paramstr(3));
	  TextColor (LightGray);
	  Close (Tabulka);
	  Halt (1);
   end;
{$I+}
   BlockRead(tabulka, Vstup, sizeof(Vstup), Nacteno); {Nacti tabulku do pole}
   close(tabulka);
end;

function Najdi (Co : byte) : byte;
var
	Citac : word;
	Konec : boolean;
begin
	Konec := false;
	Citac := 1;
	repeat
		if Vstup [Citac] = Co then
		begin
			Najdi := Citac;
			Konec := true;
		end;
		inc (Citac);
	until Konec or (Citac = 256);
	if not Konec then
		Najdi := Co;
end;

procedure PrevedTabulku;
var
   Citac : byte;
begin
	 for Citac := 0 to 255 do
		 Vystup[Citac] := Najdi (Citac);
end;

procedure ZapisTabulku;
begin
	 blockwrite (FOut, Vystup, sizeof(Vystup));
end;

procedure Help;
begin
	writeln('                Program INVTAB je doplnkem utility MLATICKA.');
	writeln('               Z vami zadane tabulky vytvori tabulku opacnou.');
	writeln('   Napr. z tabulky "kamenici na latin", vytvori tabulku "latin na kameniky".');
	writeln('                   Program se spousti se dvema parametry.');
	writeln('         1. Nazev prevadene tabulky, 2. Jmeno vysledne tabulky');
	writeln;
	writeln('Napr. INVTAB.EXE kam2lat.2pt lat2kam.muj');
	Halt;
end;

procedure Banner;
begin
   writeln;
   TextColor (Yellow);
   writeln('                        INVTAB 1.0  (c)1996  2P ');
   TextColor (LightBlue);
   writeln('                            Invertor tabulek');
   TextColor (LightGray);
   writeln;
end;

begin
	 clrscr;
	 Banner;
	 if ParamCount <> 2 then
		Help;
	 assign (FOut, ParamStr(2));
	 rewrite (FOut, 1);
	 NactiTabulku (ParamStr(1));
	 PrevedTabulku;
	 ZapisTabulku;
	 Close (FOut);
end.